

#ifndef CSRC_IPS_AUDIO_PULSE_PULSETARGETDATALINE_H_
#define CSRC_IPS_AUDIO_PULSE_PULSETARGETDATALINE_H_

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <stdlib.h>
#include <pulse/error.h>
#include <pulse/thread-mainloop.h>
#include <pulse/mainloop.h>
#include <pulse/context.h>
#include <pulse/introspect.h>
#include <pulse/stream.h>
#include <pulse/sample.h>


struct pulseTargetDataLineNS{
	JavaVM * javaVM;
	JNIEnv *env;
	jclass jClassRef;
	jweak javaObjRef;
	PulseMixerProvider* pmp;

	pa_buffer_attr buffAttr;
	pa_stream* paStream;
	void * nBuf;
	jint nBufSize;
	jint nBufAvail;
	uint nBufPos;
};

typedef struct pulseTargetDataLineNS PulseTargetDataLine;

#ifdef __cplusplus
extern "C" {
#endif
JNIEXPORT jobject JNICALL Java_ips_audio_pulse_PulseTargetDataLine_init(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseTargetDataLine_open(JNIEnv *, jobject,jobject,jstring,jint, jint,jint, jint, jboolean,jint,jint);
JNIEXPORT jint JNICALL Java_ips_audio_pulse_PulseTargetDataLine_available(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseTargetDataLine_write(JNIEnv *, jobject,jobject,jbyteArray,jint,jint);
JNIEXPORT jlong JNICALL Java_ips_audio_pulse_PulseTargetDataLine_bytePosition(JNIEnv *, jobject,jobject);
JNIEXPORT jlong JNICALL Java_ips_audio_pulse_PulseTargetDataLine_usecPosition(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseTargetDataLine_flushBegin(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseTargetDataLine_drainBegin(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseTargetDataLine_close(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseTargetDataLine_release(JNIEnv *, jobject,jobject);

#ifdef __cplusplus
}
#endif

void rec_stream_cb(pa_stream *, void *);

#endif /* CSRC_IPS_AUDIO_PULSE_PULSEMIXERPROVIDER_H_ */
